unit hiMACIP; {  MACIP (   MAC-  ) ver 1.00 }

interface

uses Windows,KOL,Share,Debug;

const
  MAX_ADAPTER_NAME_LENGTH = 256;
  MAX_ADAPTER_DESCRIPTION_LENGTH = 128;
  MAX_ADAPTER_ADDRESS_LENGTH = 8;

type
//------IP address structures---------------------------------------------------
  PIP_ADDRESS_STRING = ^IP_ADDRESS_STRING;
  IP_ADDRESS_STRING = array[0..15] of char; // IP as string

  PIP_ADDR_STRING = ^IP_ADDR_STRING;
  IP_ADDR_STRING = record
    Next: PIP_ADDR_STRING;
    IpAddress: IP_ADDRESS_STRING;
    IpMask: IP_ADDRESS_STRING;
    Context: DWORD;
  end;
//------ADAPTER INFO STRUCTURES-------------------------------------------------
  PIP_ADAPTER_INFO = ^IP_ADAPTER_INFO;
  IP_ADAPTER_INFO = record
    Next: PIP_ADAPTER_INFO;
    ComboIndex: DWORD;
    AdapterName: array[1..MAX_ADAPTER_NAME_LENGTH + 4] of char;
    Description: array[1..MAX_ADAPTER_DESCRIPTION_LENGTH + 4] of char;
    AddressLength: UINT;
    Address: array[1..MAX_ADAPTER_ADDRESS_LENGTH] of byte;
    Index: DWORD;
    aType: UINT;
    DHCPEnabled: UINT;
    CurrentIPAddress: PIP_ADDR_STRING;
    IPAddressList: IP_ADDR_STRING;
    GatewayList: IP_ADDR_STRING;
    DHCPServer: IP_ADDR_STRING;
    HaveWINS: BOOL;
    PrimaryWINSServer: IP_ADDR_STRING;
    SecondaryWINSServer: IP_ADDR_STRING;
    LeaseObtained: LongInt;
    LeaseExpires: LongInt;
    SpareStuff: array [1..200] of char;
  end;

type
 ThiMACIP = class(TDebug)
   private
      FMAC: string;
      FIP: string;
      FMask: string;
      FGateway: string;
      FDescription: string;
   public
      _event_onMACIP :THI_Event;
      _event_onEndEnum :THI_Event;
      procedure _work_doMACIP(var _Data:TData; Index:word);
      procedure _var_MAC(var _Data:TData; Index:word);
      procedure _var_IP(var _Data:TData; Index:word);
      procedure _var_Mask(var _Data:TData; Index:word);
      procedure _var_Gateway(var _Data:TData; Index:word);
      procedure _var_Description(var _Data:TData; Index:word);
   end;


implementation

function  GetAdaptersInfo(pAdapterInfo: PIP_ADAPTER_INFO; pOutBufLen: PULONG): DWORD; stdcall;
          external 'Iphlpapi.dll' name 'GetAdaptersInfo';


procedure ThiMACIP._var_MAC;
begin
   dtString(_Data, FMAC);
end;

procedure ThiMACIP._var_IP;
begin
   dtString(_Data, FIP);
end;

procedure ThiMACIP._var_Mask;
begin
   dtString(_Data, FMask);
end;

procedure ThiMACIP._var_Gateway;
begin
   dtString(_Data, FGateway);
end;

procedure ThiMACIP._var_Description;
begin
   dtString(_Data, FDescription);
end;

procedure ThiMACIP._work_doMACIP;
var
   L: DWORD;
   Size: DWORD;
   i: DWORD;
   Next: PIP_ADAPTER_INFO;
   Count: Integer;
begin
   Size := Sizeof( IP_ADAPTER_INFO );
   Next := AllocMem( Size );
   L:= GetAdaptersInfo(Next, @Size);
   if L = ERROR_BUFFER_OVERFLOW then
   begin
      FreeMem( Next );
      Next := AllocMem( Size );
      L:= GetAdaptersInfo(Next, @Size);
   end;
   Count := 0;
   if L = NO_ERROR then begin
      repeat
         FDescription := Next^.Description;
         FIP := Next^.IPAddressList.IpAddress;
         FMask := Next^.IPAddressList.IpMask;
         FGateway := Next^.GatewayList.IpAddress;
         FMAC:= '';
         for i := 1 to Next^.AddressLength do begin
            FMAC:= FMAC + Int2Hex(Next^.Address[i], 2);
            if i <> Next^.AddressLength then FMAC:= FMAC + '-';
         end;
         inc(Count);
         _hi_onEvent(_event_onMACIP);
         Next:= Next^.Next; //    
      until Next = nil;
   end;
   _hi_CreateEvent(_Data, @_event_onEndEnum, Count);
end;

end.